package sinhalatts_vbeta;

import java.util.ArrayList;
import java.util.regex.*;
import java.io.RandomAccessFile;
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;

class TextNormalizerCaller {

  static ArrayList Symbol;
  static ArrayList Def;
  static ArrayList CurrencyList;
  static ArrayList PhoneList;
  static ArrayList TimeList;
  static ArrayList closingList;
  static ArrayList diphone;
  static ArrayList PreDefWord;
  static ArrayList PreDefReplace;

  static TextNormalizer tn = new TextNormalizer();
  static String Diphones;

  static RandomAccessFile finalFile;
  static RandomAccessFile rafforDiphone;
  static boolean isCreate = false;

  static String tempFilePath = ".\\Temp.tem";
  static String outFilePath = ".\\Res.out";
  static String preWordTagsFilePath = ".\\Resources\\preWordTags.res";
  static String ClosingListFilePath = ".\\Resources\\ClosingList.res";
  static String SymbolsFilePath = ".\\Resources\\Symbols.res";
  static String preDefListFilePath = ".\\Resources\\PreDefList.res";

//////////////////////////////////////////////////////////////////////////

  public static boolean normalize(String selectedPath) {

    UnicodeFileTokenizer uft = new UnicodeFileTokenizer(selectedPath);
    NumReader nr = new NumReader();

    ArrayList preWord;
    ArrayList midWord;
    ArrayList endWord;
    ArrayList word = new ArrayList(1);
    ArrayList Nextword = new ArrayList(1);
    ArrayList compound = new ArrayList(1);

    byte goingtoDie = 0;

    boolean goingtoEnter = false;
    boolean divitionChecker = false;
    boolean currency = false;
    boolean phone = false;
    boolean time = false;
    boolean isPhone = false;
    boolean spaceAdder = false;
    boolean decimalCheker = false;
    boolean spaceChecker = false;
    boolean firstOne = true;
    boolean switcher = false;

    try {

      File f = new File(outFilePath);

      if (f.exists())
        f.delete();

      finalFile = new RandomAccessFile(outFilePath, "rw");

      f = new File(tempFilePath);

      if (f.exists())
        f.delete();

     rafforDiphone = new RandomAccessFile(tempFilePath, "rw");

     isCreate = true;

      word = tn.prefixFiller(uft.nextToken());

      while (true) {

        preWord = new ArrayList(1);
        midWord = new ArrayList(1);
        endWord = new ArrayList(1);

        Nextword = tn.prefixFiller(uft.nextToken());
        fillLists(preWordTagsFilePath, ClosingListFilePath);
        fillSymbols();

        if (tn.isWithNum(word)) {

          TextNormalizer.Element n = tn.NumDetecter(word);

          if (!n.isValid()) {
            for (int i = 0; i < word.size(); i++) {
              if (Symbol.indexOf(word.get(i)) > 0)
                preWord.addAll( (ArrayList) Def.get(Symbol.indexOf(word.get(i))));
              else
                preWord.add(word.get(i));
              preWord.add("0020");
            }
            word.clear();
          } //isValid()

          else { // isvalid()

            if (phone || (readSimply(word) && n.getSymbols().size() < 2)) {
              midWord = nr.simpleReader(word);
              if (tn.isWithNum(Nextword))
                isPhone = true;
              else
                isPhone = false;
            }

            else { // no Phone

              if (!n.getPrefix().equals("")) {
                preWord = tn.prefixFiller(n.getPrefix());
                preWord.add("0020");
              } //prefix

              //**************Add precentage mark*********************
               if (n.isPrecentage()) {
                 preWord.add("0dc3");
                 preWord.add("0dd2");
                 preWord.add("0dba");
                 preWord.add("0dba");
                 preWord.add("0da7");
                 preWord.add("0020");
               }

              if (n.getSymbols().size() > 1) {
                preWord.addAll(tn.sufixFixer(nr.read(n.getNumaric().get(n.
                    getNumaric().size() - 3).toString()), "0dba0dd20020", 1));
                preWord.add("0020");
              }

              if (n.getSymbols().size() > 0) {

                //*************Check the divition mark*************
                 if (n.getSymbols().get(n.getSymbols().size() - 1).toString().
                     equals("002f") && n.getSymbols().size() < 2) {
                   divitionChecker = true;
                   endWord = tn.sufixFixer(nr.read(n.getNumaric().get(n.
                       getNumaric().size() - 1).toString()), "0db10dca", 3);
                   endWord.add("0020");
                   if (!n.getSufix().equals(""))
                     midWord = tn.sufixFixer(nr.read(n.getNumaric().get(n.
                         getNumaric().size() - 2).toString()),
                                             n.getSufix(),
                                             tn.sufixDetecter(n.getSufix()));
                   else { // no suffix
                     Node node = new Node();
                     if (nextWordProcesser(Nextword, node)) {
                       midWord = tn.sufixFixer(nr.read(n.getNumaric().get(n.
                           getNumaric().size() - 2).toString()),
                                               node.sufix,
                                               node.Category);
                       Nextword = tn.prefixFiller(uft.nextToken());
                     }
                     else
                       midWord = nr.read(n.getNumaric().get(n.
                           getNumaric().size() - 2).toString());
                   } //no sufix
                 } //Divition Mark

                 else { // not Devision

                   if (Integer.parseInt(n.getNumaric().get(n.getNumaric().
                       size() - 1).toString()) == 0 && !n.getSufix().equals(""))
                     midWord.addAll(tn.sufixFixer(nr.read(n.getNumaric().get(n.
                         getNumaric().size() - 2).toString()), n.getSufix(),
                                                  tn.sufixDetecter(n.getSufix())));

                   else {
                     midWord.addAll(tn.sufixFixer(nr.read(n.getNumaric().get(n.
                         getNumaric().size() - 2).toString()), "0dba0dd2", 1));
                     midWord.add("0020");
                   }

                   //*************Add the decimal indicator*************
                    if (n.getSymbols().get(n.getSymbols().size() - 1).toString().
                        equals("002e")) {
                      decimalCheker = true;
                      if (n.getPrefix().equals("0dbb0dd4002e"))
                        currency = true;
                    }

                   if (decimalCheker && !time && !currency) {
                     midWord.add("0daf");
                     midWord.add("0dc1");
                     midWord.add("0db8");
                     midWord.add("0020");

                     if (!n.getSufix().equals(""))
                       endWord = tn.sufixFixer(nr.simpleReader(n.
                           getNumaric().get(n.getNumaric().size() - 1).
                           toString(),
                           "f"), n.getSufix(), tn.sufixDetecter(n.getSufix()));
                     else {
                       Node node = new Node();
                       if (nextWordProcesser(Nextword, node)) {
                         endWord = tn.sufixFixer(nr.simpleReader(n.
                             getNumaric().get(n.getNumaric().size() - 1).
                             toString(),
                             "f"), node.sufix, node.Category);
                         Nextword = tn.prefixFiller(uft.nextToken());
                       }
                       else
                         endWord = nr.simpleReader(n.getNumaric().get(n.
                             getNumaric().size() - 1).toString(), "f");
                     }
                   } // if detect Desimal

                   else {
                     if (Integer.parseInt(n.getNumaric().get(n.getNumaric().
                         size() - 1).toString()) != 0) {
                       //**************Add last element*********************
                        if (!n.getSufix().equals(""))
                          endWord = tn.sufixFixer(nr.read(n.getNumaric().get(n.
                              getNumaric().size() - 1).toString()),
                                                  n.getSufix(),
                                                  tn.sufixDetecter(n.getSufix()));
                        else { // no suffix
                          Node node = new Node();
                          if (nextWordProcesser(Nextword, node)) {
                            endWord = tn.sufixFixer(nr.read(n.getNumaric().get(
                                n.
                                getNumaric().size() - 1).toString()),
                                node.sufix,
                                node.Category);
                            Nextword = tn.prefixFiller(uft.nextToken());
                          }
                          else
                            endWord = nr.read(n.getNumaric().get(n.
                                getNumaric().size() - 1).toString());
                        } //no sufix

                       if (Nextword.toString().equals(
                           "[0daf, 0d9a, 0dca, 0dc0, 0dcf]") &&
                           (n.getSymbols().get(n.getSymbols().size() - 1).
                            toString().
                            equals("002d") ||
                            n.getSymbols().get(n.getSymbols().size() - 1).
                            toString().
                            equals("2013"))) {
                         midWord.clear();
                         midWord.addAll(tn.sufixFixer(nr.read(n.getNumaric().
                             get(
                             n.
                             getNumaric().size() - 2).toString()),
                             "00200dc30dd20da7", 4));
                         midWord.add("0020");
                       }
                       else if (currency) {
                         midWord.add("0dc1");
                         midWord.add("0dad");
                         midWord.add("0020");
                       }
                     } //no Zero
                   } // no decimal
                 } // Divition Else
              } //if Have some symbols

              else {
                if (!n.getSufix().equals(""))
                  midWord = tn.sufixFixer(nr.read(n.getNumaric().get(0).
                                                  toString()),
                                          n.getSufix(),
                                          tn.sufixDetecter(n.getSufix()));
                else {
                  Node node = new Node();
                  if (nextWordProcesser(Nextword, node)) {
                    midWord = tn.sufixFixer(nr.read(n.getNumaric().get(0).
                        toString()),
                                            node.sufix,
                                            node.Category);
                    Nextword = tn.prefixFiller(uft.nextToken());
                  }
                  else
                    midWord = nr.read(n.getNumaric().get(0).toString());
                }
              } //if no symbols
            } //phone else
          } //if Valid (else)
        } //if Num

        else
          midWord = word;

        currency = false;
        phone = false;
        time = false;
        decimalCheker = false;

        if (CurrencyList.contains(word))
          currency = true;
        if (PhoneList.contains(word) || isPhone)
          phone = true;
        if (TimeList.contains(word))
          time = true;

        if (divitionChecker) {
          preWord.addAll(endWord);
          preWord.addAll(midWord);
        }
        else {
          preWord.addAll(midWord);
          preWord.addAll(endWord);
        }

        divitionChecker = false;

        int detecter = 0;
        boolean needtoConvert = false;
        boolean isOutRange = false;

        for (int i = 0; i < preWord.size(); i++) {

          isOutRange = false;
          detecter = Integer.parseInt(preWord.get(i).toString(), 16);

          if ( (127 < detecter && detecter < 3457) || 3573 < detecter)
            isOutRange = true;

          switch (detecter) {
            case 35:
            case 36:
            case 37:
            case 38:
            case 40:
            case 41:
            case 42:
            case 43:
            case 45:
            case 47:
            case 60:
            case 61:
            case 62:
              needtoConvert = true;
              break;
            default:
              needtoConvert = false;
          }

          ArrayList toAdd;

          if ( (detecter > 63 && detecter < 126) || needtoConvert || isOutRange) {

            if (isOutRange) {
              toAdd = (ArrayList) Def.get(Symbol.indexOf("0060"));
              preWord.remove(i);
            }
            else
              toAdd = (ArrayList) Def.get(Symbol.indexOf(preWord.
                  remove(
                  i).toString()));

            preWord.add(i++, "0020");
            for (int j = 0; j < toAdd.size(); j++)
              preWord.add(i++, toAdd.get(j).toString());
            preWord.add(i--, "0020");
          }
        } //for
        spaceChecker = trim(preWord);
        spaceAdder(preWord);
        diphone = new ArrayList(1);
        diphone.addAll(preWord);
        Diphones = tn.diphoneSet(diphone);

        if (firstOne) {
          rafforDiphone.writeBytes(Diphones);
          firstOne = false;
        }
        else {
          if (!spaceChecker)
            rafforDiphone.write(32);
          rafforDiphone.writeBytes(Diphones);
        }

        if (goingtoEnter) {
          rafforDiphone.write(46);
          rafforDiphone.write(13);
          rafforDiphone.write(10);
          goingtoEnter = false;
          firstOne = true;
        }

        if (uft.isEnter())
          goingtoEnter = true;

        word = Nextword;

        if (uft.isEnd()) {
          goingtoDie++;
          if (goingtoDie > 1)
            break;
        }
      } //while

      rafforDiphone.close();

      PreDefListFiller();
      CharSequence cs = fromFile(tempFilePath);
      String text = cs.toString();

      for (int i = 0; i < PreDefWord.size(); i++) {
        text = RegExIdentifier03(text, PreDefWord.get(i).toString(),
                                 PreDefReplace.get(i).toString());
      }

      addRules(text, finalFile);

    } //try

    catch (Exception io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch
    return true;
  } //normalize()

//////////////////////////////////////////////////////////////////////////

  public static void closeFiles() throws java.io.IOException {
    if(isCreate) {
      rafforDiphone.close();
      finalFile.close();
    }
  } //deleteFiles()

//////////////////////////////////////////////////////////////////////////

  private static void fillSymbols() throws java.io.IOException {
    Symbol = new ArrayList(1);
    Def = new ArrayList(1);
    ArrayList Token = new ArrayList(1);
    UnicodeFileReader ufr = new UnicodeFileReader(SymbolsFilePath);
    UnicodeTokenizer ut;
    while (!ufr.isEnd()) {
      ut = new UnicodeTokenizer(ufr.readLine(), "0009", "uni");
      Token = ut.nextToken();
      if (Token.size() == 0)
        break;
      Symbol.add(Token.get(0));
      Def.add(ut.nextToken());
    }
  } //fillSymbols()

//////////////////////////////////////////////////////////////////////////

  private static boolean nextWordProcesser(ArrayList word, Node n) {
    for (int i = 0; i < word.size(); i++)
      n.sufix = n.sufix.concat(word.get(i).toString());
    if (n.sufix.equals("0daf0dd3") || n.sufix.equals("0dc30dd20da7")) {
      n.Category = 4;
      return true;
    }
    else if (n.sufix.equals("0db10dca") || n.sufix.startsWith("0dc40dd2") ||
             n.sufix.equals("0db10dca0db8")) {
      n.Category = 3;
      return true;
    }
    else if (n.sufix.startsWith("0dc00dd90db1") ||
             n.sufix.startsWith("0dc00db1") ||
             n.sufix.startsWith("0dc00dd00db1") ||
             n.sufix.startsWith("0daf0dd90db1")) {
      n.Category = 2;
      return true;
    }
    else
      return false;

  } // nextWordProcesser()

//////////////////////////////////////////////////////////////////////////

  private static boolean readSimply(ArrayList in) {
    if (in.size() > 9 && (in.get(in.size() - 1).toString().equals("0056") ||
                          in.get(in.size() - 1).toString().equals("0076")))
      return true;
    else if ( (in.contains("002c") || in.contains("002f") || in.contains("002e") ||
               in.contains("003a")) &&
             !in.get(in.size() - 1).toString().equals("002c"))
      return false;
    else if (in.get(0).toString().equals("0030") && in.size() > 2 &&
             in.get(in.size() - 1).toString().charAt(2) == '3' &&
             Character.isDigit(in.get(in.size() - 1).toString().charAt(3)))
      return true;
    else if (in.get(0).toString().equals("0028") && in.size() > 6)
      return true;
    else if (in.get(0).toString().equals("0032") && in.size() > 5)
      return true;
    else
      return false;
  } //readSimply()

//////////////////////////////////////////////////////////////////////////

  private static void fillLists(String path1, String path2) throws java.io.
      IOException {

    UnicodeFileReader ufr = new UnicodeFileReader(path1);
    CurrencyList = new ArrayList(1);
    PhoneList = new ArrayList(1);
    TimeList = new ArrayList(1);
    closingList = new ArrayList(1);
    ArrayList line = new ArrayList(1);
    byte switcher = 0;

    while (!ufr.isEnd()) {
      line = ufr.readLine();
      if (line.size() == 0)
        break;

      if (line.get(0).toString().equals("0043")) {
        switcher = 1;
        continue;
      }
      if (line.get(0).toString().equals("0050")) {
        switcher = 2;
        continue;
      }
      if (line.get(0).toString().equals("0054")) {
        switcher = 3;
        continue;
      }

      switch (switcher) {
        case 1:
          CurrencyList.add(line);
          break;
        case 2:
          PhoneList.add(line);
          break;
        case 3:
          TimeList.add(line);
          break;
      }
    } //while

    ufr = new UnicodeFileReader(path2);
    while (!ufr.isEnd()) {
      line = ufr.readLine();
      if (line.size() == 0)
        break;
      closingList.add(line);
    }

  } //fillLists()

//////////////////////////////////////////////////////////////////////////

  private static boolean trim(ArrayList word) {

    UnicodeTokenizer ut = new UnicodeTokenizer(word);
    ArrayList newWord = new ArrayList(1);
    ArrayList nextWord = new ArrayList(1);
    boolean checker = false;

    newWord = ut.nextToken();
    if (closingList.contains(newWord))
      checker = true;

    while (!ut.isEnd()) {
      nextWord = ut.nextToken();
      if (nextWord.size() == 0)
        continue;
      if (closingList.contains(nextWord) || checker) {
        checker = false;
        newWord.addAll(nextWord);
      }
      else {
        if (!newWord.get(newWord.size() - 1).toString().equals("0028"))
          newWord.add("0020");
        newWord.addAll(nextWord);
      }
    } //while
    word.clear();
    word.addAll(newWord);
    return checker;
  } //trim

//////////////////////////////////////////////////////////////////////////

  private static void spaceAdder(ArrayList list) {
    for (int i = 0; i < list.size(); i++) {
      if (list.get(i).toString().equals("0021") ||
          list.get(i).toString().equals("0022") ||
          list.get(i).toString().equals("0027") ||
          list.get(i).toString().equals("002c") ||
          list.get(i).toString().equals("002e") ||
          list.get(i).toString().equals("003a") ||
          list.get(i).toString().equals("003b") ||
          list.get(i).toString().equals("003f")) {
        if (i == list.size() - 1)
          list.add("0020");
        else {
          list.add(++i, "0020");
          list.add(++i, "0020");
        }
      }
    }
  } //spaceAdder

//////////////////////////////////////////////////////////////////////////

  private static void addRules(String in, RandomAccessFile out) throws
      IOException {

    String NormalizingWord_01 = "";
    String NormalizingWord_02 = "";

    // Rule 3
    NormalizingWord_02 = RegExIdentifier01(in,
        "(k|g|q|ngz|c|j|cnz|njz|t|d|n|ndz|thz|dhz|w|p|b|m|mbz|y|r|l|v|shz|s|h|f)raxzh",
                                           5, "rah");

// Rule 4
    NormalizingWord_01 = RegExIdentifier01(NormalizingWord_02,
                                           "(a|e|ae|o|axz)haxz", 4, "ha");

// Rule 06
    NormalizingWord_02 = "";
    NormalizingWord_02 = RegExIdentifier02(NormalizingWord_01,
        "axz(k|g|q|ngz|c|j|cnz|njz|n|ndz|thz|dhz|w|p|m|mbz|y|l|v|shz|s|h|f) ",
        3, "a");

// Rule 07
    NormalizingWord_01 = "";
    NormalizingWord_01 = RegExIdentifier02(NormalizingWord_02, "axzyi( |\\.)", 4, "a");

// Rule 08
    NormalizingWord_02 = "";
    NormalizingWord_02 = RegExIdentifier02(NormalizingWord_01, "kaxz(l|r)u", 4,
                                            "ka");

// Rule 09
    NormalizingWord_01 = "";
    NormalizingWord_01 = RegExIdentifier02(NormalizingWord_02,
                                            "kal(aaz|eez|ooz)y", 3, "kaxzl");

// Rule 10
    NormalizingWord_02 = "";
    NormalizingWord_02 = RegExIdentifier02(NormalizingWord_01,
                                            "kale(m|h)(u|i)", 4,
                                            "kaxzle");

// Detecting English initials
    NormalizingWord_01 = "";
    NormalizingWord_01 = RegExIdentifier01(NormalizingWord_02,
                                           "( eez. | biiz. | siiz. | diiz. | iiz. | ef. | jiiz. | ec. | ayi. | jeez. | keez. | el. | em. | en. | ooz. | piiz. | kyu. | aazr. | es. | tiiz. | yuuz. | viiz. | dabliv. | eks. | vayi. | ised. )",
                                           1, "");
// Remove unacepted chars
    NormalizingWord_02 = "";
    NormalizingWord_02 = RegExIdentifier01(NormalizingWord_01,
                                            Character.toString((char)29), 1,
                                            "");

    out.writeBytes(NormalizingWord_02);
    out.close();
  } //addRules

/////////////////////////////////////////////////////////////////////////////

  private static String RegExIdentifier01(String word, String RexEx,
                                          int deducter, String Rep) {
    String replase;
    Pattern p = Pattern.compile(RexEx);
    Matcher m = p.matcher(word);
    StringBuffer sb = new StringBuffer();
    while (m.find()) {
      replase = m.group().substring(0, m.group().length() - deducter);
      replase = replase.concat(Rep);
      m.appendReplacement(sb, replase);
    }
    m.appendTail(sb);
    return sb.toString();
  } //RegExIdentifier02

//////////////////////////////////////////////////////////////////////////

  private static String RegExIdentifier02(String word, String RexEx,
                                          int deducter, String Rep) {
    String replase;
    Pattern p = Pattern.compile(RexEx);
    Matcher m = p.matcher(word);
    StringBuffer sb = new StringBuffer();
    while (m.find()) {
      replase = m.group().substring(deducter);
      replase = Rep.concat(replase);
      m.appendReplacement(sb, replase);
    }
    m.appendTail(sb);
    return sb.toString();
  } //RegExIdentifier02

//////////////////////////////////////////////////////////////////////////

  private static String RegExIdentifier03(String word, String RexEx, String replase) {
    Pattern p = Pattern.compile(RexEx);
    Matcher m = p.matcher(word);
    StringBuffer sb = new StringBuffer();
    while (m.find())
      m.appendReplacement(sb, replase);
    m.appendTail(sb);
    return sb.toString();
  } //RegExIdentifier03

/////////////////////////////////////////////////////////////////////////////

  private static void PreDefListFiller() throws java.io.IOException {
    PreDefWord = new ArrayList(1);
    PreDefReplace = new ArrayList(1);
    UnicodeFileReader ufr = new UnicodeFileReader(preDefListFilePath);
    UnicodeTokenizer ut;
    while (!ufr.isEnd()) {
      ut = new UnicodeTokenizer(ufr.readLine(), "0009", "uni");
      PreDefWord.add(tn.diphoneSet(ut.nextToken()));
      PreDefReplace.add(tn.diphoneSet(ut.nextToken()));
    }
  } //PreDefListFiller()

//////////////////////////////////////////////////////////////////////////
  // Converts the contents of a file into a CharSequence
  // suitable for use by the regex package.
  private static CharSequence fromFile(String filename) throws IOException {
    FileInputStream fis = new FileInputStream(filename);
    java.nio.channels.FileChannel fc = fis.getChannel();

    // Create a read-only CharBuffer on the file
    ByteBuffer bbuf = fc.map(java.nio.channels.FileChannel.MapMode.READ_ONLY, 0,
                             (int) fc.size());
    CharBuffer cbuf = java.nio.charset.Charset.forName("8859_1").newDecoder().
        decode(bbuf);
    return cbuf;
  } //fromFile

//////////////////////////////////////////////////////////////////////////

  static class Node {
    String sufix = "";
    int Category = 0;
  } // class Node

} //Class